<?php
// $Id: agres_funcs.inc,v 1.1.2.4 2010/12/23 02:25:46 agill Exp $
/**
 * @file
 * helper functions. not only usefull for agreservations
 */

/**
  * _install_bundle_fields: inspired by features module.
  *
  */
function _install_bundle_fields($fields) {
  if (isset($fields)) {
    field_info_cache_clear();
    foreach ($fields as $field) {
      // Create or update field.
      $field_config = $field['field_config'];
      if ($existing_field = field_info_field($field_config['field_name'])) {
        field_update_field($field_config);
      }
      else {
        field_create_field($field_config);
      }

      // Create or update field instance.
      $field_instance = $field['field_instance'];
      $existing_instance = field_info_instance($field_instance['entity_type'], $field_instance['field_name'], $field_instance['bundle']);
      if ($existing_instance) {
        field_update_instance($field_instance);
      }
      else {
        field_create_instance($field_instance);
      }
      variable_set('menu_rebuild_needed', TRUE);
    }
  }
}

/**
  * in_multi_assoc_array: returns BOOLEAN.
  *
  * @author     Andreas Gill
  * @param      $needle zu suchender Wert.
  * @param      $array   zu durchsuchendes Array.
  * @return     TRUE oder FALSE
  */
    function in_multi_assoc_array($needle, $array)
    {
        foreach ($array as $element){
           if ($element == $needle) {
               return true;
           }else{
               if (is_array($element)){
                 if(in_multi_assoc_array($needle,$element)){
                     return true;
                 }
               }
           }
        }
        return false;
    }
    /**
  * _is_time_in_range: returns BOOLEAN.
  *
  * @author     Andreas Gill
  * @param      $timetocheck time to check.timestring'H:i'
  * @param      $rangelow lower end of timerange.timestring'H:i'
  * @param      hrangehigh higher end of timerange.timestring of form 'H:i'
  * @return     TRUE if in range or FALSE if not within range
  */
    function _is_time_in_range($timetocheck, $rangelow,$rangehigh){
      $strtimetocheck = date('H:i',strtotime($timetocheck));
       if ((strtotime($strtimetocheck) >= strtotime($rangelow))&&(strtotime($strtimetocheck) <= strtotime($rangehigh))) {        
          return TRUE;
       }
       else {
         return FALSE;
       }
    }
  /**
  * _is_date_in_range: returns BOOLEAN.
  *
  * @author     Andreas Gill
  * @param      $datetocheck, date to check. timestring 'Y-m-d'
  * @param      $rangelow lower end of daterange.timestring'Y-m-d'
  * @param      hrangehigh higher end of daterange.timestring of form 'Y-m-d'
  * @return     TRUE if in range or FALSE if not within range
  */
    function _is_date_in_range($datetocheck, $rangelow,$rangehigh){                      
      $strdatetocheck = date_format(new DateObject($datetocheck), 'Y-m-d');
      $strrangelow = date_format(new DateObject($rangelow), 'Y-m-d');
      $strrangehigh = date_format(new DateObject($rangehigh), 'Y-m-d');
       if ((strtotime($strdatetocheck) >= strtotime($strrangelow))&&(strtotime($strdatetocheck) <= strtotime($strrangehigh))) {
          return TRUE;
       }
       else {
         return FALSE;
       }
    }

 /**
  * get_current_path: current url
  * from drupaluser dhaneshharidas 
  * from http://drupal.org/node/46088
  */
  function get_current_path() { 
    
    $tmpdest = '';
    $tmpdest = drupal_get_destination();   
//    drupal_set_message('<pre>get_current_path'.print_r($tmpdest,true).'</pre>');
  $current_path = explode('=', $tmpdest['destination']);
  
  // Extracting URL from $current_path
  if (is_array($current_path) && count($current_path) >= 1) {
    if (trim($current_path[0]) != '') {
      $current_url_full = htmlspecialchars(urldecode($current_path[0]));
      // Removing query string
      $current_url_elements = explode('?', $current_url_full);
      if (is_array($current_url_elements)) {
        return trim($current_url_elements[0]);
      } else {
        return trim($current_url_elements);
      }
    } else {
      
      return $_REQUEST['q'];
    }
  }
  
}

 /**
  * createDateRangeArray: current url
  * @author   Mike Boone
  * @param    $strDateFrom Y-m-d
  * @param    $strDateTo Y-m-d
  * @return   creates an inclusive array of the dates between the from and to dates.
  * from http://boonedocks.net/mike/archives/137-Creating-a-Date-Range-Array-with-PHP.html
  */
function createDateRangeArray($strDateFrom,$strDateTo) {
  // takes two dates formatted as Y-m-d and creates an
  // inclusive array of the dates between the from and to dates.

  // could test validity of dates here but I'm already doing
  // that in the main script
  $aryRange=array();
//   drupal_set_message('<pre>createDateRangeArray: ' . print_r($strDateFrom.'--'.$strDateTo, true) . '</pre>');
  $iDateFrom=mktime(1,0,0,substr($strDateFrom,5,2),     substr($strDateFrom,8,2),substr($strDateFrom,0,4));
  $iDateTo=mktime(1,0,0,substr($strDateTo,5,2),     substr($strDateTo,8,2),substr($strDateTo,0,4));

  if ($iDateTo>=$iDateFrom) {
    array_push($aryRange,date('Y-m-d',$iDateFrom)); // first entry

    while ($iDateFrom<$iDateTo) {      
      $iDateFrom=strtotime("+1 day",$iDateFrom);//86400; // add 24 hours
      array_push($aryRange,date('Y-m-d',$iDateFrom));
    }
  }
//  drupal_set_message('<pre>$aryRange: ' . print_r($aryRange, true) . '</pre>');
  return $aryRange;
}